function [B,P]=ACfiltering(A,CentFreqs,FS)
%
% Irino's asymmetrical compensation filterbank. This calls
% ACbank which is a fast MEX-implementation of an ad hoc
% adaptation routine (something like this could be happening 
% in an ear)
%
% This file is a part of HUTear- Matlab toolbox for auditory
% modeling. The toolbox is available at 
% http://www.acoustics.hut.fi/software/HUTear/

% Copyrights: Aki Hrm, Helsinki University of Technology, 
% Laboratory of Acoustics and Audio Signal Processing, 
% Espoo, Finland.
% Date: August 20 1999
% Email: Aki.Harma@hut.fi

dim=size(A);
B=zeros(dim);
P=zeros(dim);

for q=1:dim(2),
  [B(:,q),P(:,q)]=ACbank(A(:,q),CentFreqs(q),FS);
end

