function ret=Dau_network96(S,thr)
%
% ret=Dau_network96(S,thr)
%
% An implementation of Puschel's nonlinear adaptation network.
% 
% Parameters derived from (Dau, 1996)
% t=5,50,129,253,500 ms
%
% This file is a part of HUTear- Matlab toolbox for auditory
% modeling. The toolbox is available at 
% http://www.acoustics.hut.fi/software/HUTear/

% Copyrights: Aki Hrm, Helsinki University of Technology, 
% Laboratory of Acoustics and Audio Signal Processing, 
% Espoo, Finland.
% Date: August 20 1999
% Email: Aki.Harma@hut.fi

dim=size(S);dim=min(dim);

% Leakage matrix
%w=[1.0 -0.3 -0.1 -0.01 zeros(1,dim-4)];%w=w/sum(w);
%T=toeplitz(w,w);

% Time constants to coefficients at 44.1 kHz
b=exp(-1./([5 50 129 253 500]*44.1));

% Threshold
S=max(S,thr);

o=Puschel_stageM(S,b(1),1);
o=Puschel_stageM(o,b(2),1);
o=Puschel_stageM(o,b(3),1);
o=Puschel_stageM(o,b(4),1);
o=Puschel_stageM(o,b(5),1);

%Lim=100;
%o=InfoMask(o,Lim);
ret=filter(1-0.9992,[1 -0.9992],o);
%b=0.9996;ret=filter(1-3*b+3*b^2-b^3,[1 -3*b +3*b^2 -b^3],o);
%ret=AdaptModA(o,0.01,0.002);
%ret=o;
