function x=Greenwood90(f,sw)
%
% x=Greenwood90(f,sw)
%
% Greenwood's (1990) frequency-to-location mapping: 
% x=Greenwood90(f,'Hz2x')
% 
% Inverse mapping:
% f=Greenwood90(x,'x2Hz')
%
% This file is a part of HUTear- Matlab toolbox for auditory
% modeling. The toolbox is available at 
% http://www.acoustics.hut.fi/software/HUTear/

% Copyrights: Aki Hrm, Helsinki University of Technology, 
% Laboratory of Acoustics and Audio Signal Processing, 
% Espoo, Finland.
% Date: August 20 1999
% Email: Aki.Harma@hut.fi

MaxLoc=35.5;

switch sw,
  case 'Hz2x', x=16.7*log10(f/165.4 +1)/MaxLoc;break;
  case 'x2Hz', x=165.4*(10.^(0.06*f*MaxLoc)-1);break;
end



