function [A,B,cf]=Make_cgtbank(N,fs,LowF,ord)
%
% A,B]=Make_cgtbank(N,fs,LowF,ord)
%
% Design a complex-valued gammatone filterbank with N channels. 
% The order of the gammatone filter, ord,  can be 4 or 6. 
% This function is used by Make_GTbank.
%
% This file is a part of HUTear- Matlab toolbox for auditory
% modeling. The toolbox is available at 
% http://www.acoustics.hut.fi/software/HUTear/

% Copyrights: Aki Hrm, Helsinki University of Technology, 
% Laboratory of Acoustics and Audio Signal Processing, 
% Espoo, Finland.
% Date: August 20 1999
% Email: Aki.Harma@hut.fi

FS=44100;

if length(LowF)==1,
  fc=linspace(Greenwood90(LowF,'Hz2x'),Greenwood90(fs/2,'Hz2x'),N);
  fc=Greenwood90(fc,'x2Hz');
else
  fc=LowF;
  N=length(LowF);
end

bw=ERB(fc)/fs;
fc=-fc/(fs);
phase=0;

A=zeros(N,ord);
B=zeros(N,ord+1);

for q=1:N,
	[A(q,:) B(q,:)]=CGT(fc(q),bw(q),phase,ord);
end

cf=-fc*fs;



