function fig = OEMtool(action)
% OEMtool
%
% This is an interactive graphical user interface for design
% of filters for outer and middle ear attenuation. This uses
% Make_OEM function. 
%
% This file is a part of HUTear- Matlab toolbox for auditory
% modeling. The toolbox is available at 
% http://www.acoustics.hut.fi/software/HUTear/

% Copyrights: Aki Hrm, Helsinki University of Technology, 
% Laboratory of Acoustics and Audio Signal Processing, 
% Espoo, Finland.
% Date: August 20 1999
% Email: Aki.Harma@hut.fi

if nargin<1, 
  
load Oem3

h0 = figure('Color',[0.8 0.8 0.8], ...
	'Colormap',mat0, ...
	'FileName','/home/aqi/Mdesk/EXPERIMENTS/GUI/OEMtool.m', ...
	'PaperPosition',[18 180 576 432], ...
	'PaperUnits','points', ...
	'Position',[367 281 612 424], ...
	'Tag','Fig1', ...
	'ToolBar','none');
h1 = axes('Parent',h0, ...
	'Units','pixels', ...
	'CameraUpVector',[0 1 0], ...
	'CameraUpVectorMode','manual', ...
	'Color',[1 1 1], ...
	'ColorOrder',mat1, ...
	'Position',[154 38 391 360], ...
	'Tag','Axes1', ...
	'XColor',[0 0 0], ...
	'YColor',[0 0 0], ...
	'ZColor',[0 0 0]);
h2 = text('Parent',h1, ...
	'Color',[0 0 0], ...
	'HandleVisibility','off', ...
	'HorizontalAlignment','center', ...
	'Position',[0.4974358974358974 -0.06269592476489018 9.160254037844386], ...
	'Tag','Axes1Text4', ...
	'VerticalAlignment','cap');
set(get(h2,'Parent'),'XLabel',h2);
h2 = text('Parent',h1, ...
	'Color',[0 0 0], ...
	'HandleVisibility','off', ...
	'HorizontalAlignment','center', ...
	'Position',[-0.06153846153846155 0.4952978056426333 9.160254037844386], ...
	'Rotation',90, ...
	'Tag','Axes1Text3', ...
	'VerticalAlignment','baseline');
set(get(h2,'Parent'),'YLabel',h2);
h2 = text('Parent',h1, ...
	'Color',[0 0 0], ...
	'HandleVisibility','off', ...
	'HorizontalAlignment','right', ...
	'Position',mat2, ...
	'Tag','Axes1Text2', ...
	'Visible','off');
set(get(h2,'Parent'),'ZLabel',h2);
h2 = text('Parent',h1, ...
	'Color',[0 0 0], ...
	'HandleVisibility','off', ...
	'HorizontalAlignment','center', ...
	'Position',mat3, ...
	'Tag','Axes1Text1', ...
	'VerticalAlignment','bottom');
set(get(h2,'Parent'),'Title',h2);
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.701960784313725 0.701960784313725 0.701960784313725], ...
	'Callback','OEMtool(1)', ...
	'ListboxTop',0, ...
	'Max',3, ...
	'Min',1, ...
	'Position',[15 340 60 20], ...
	'String',['MAF';'MAP';'ELC'], ...
	'Style','popupmenu', ...
	'Tag','PopupMenu1', ...
	'UserData','[ ]', ...
	'Value',2);

if exist('wfilter','file')==0, % Warped Toolbox not available!   
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.701960784313725 0.701960784313725 0.701960784313725], ...
	'Callback','OEMtool(1)', ...
	'ListboxTop',0, ...
	'Max',4, ...
	'Min',1, ...
	'Position',[15 290 60 20], ...
	'String',['FIR ';'IIR '], ...
	'Style','popupmenu', ...
	'Tag','PopupMenu2', ...
	'UserData','[ ]', ...
	'Value',2);
    disp('It seems that WarpTB - Matlab toolbox for frequency-warped');
    disp('signal processing is not in your search path. It is not required,');
    disp('but You can get better filters with it. ');
    disp('See: www.acoustics.hut.fi/software/warp');
  else    % Warped Toolbox is available
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.701960784313725 0.701960784313725 0.701960784313725], ...
	'Callback','OEMtool(1)', ...
	'ListboxTop',0, ...
	'Max',4, ...
	'Min',1, ...
	'Position',[15 290 60 20], ...
	'String',['FIR ';'IIR ';'WFIR';'WIIR'], ...
	'Style','popupmenu', ...
	'Tag','PopupMenu2', ...
	'UserData','[ ]', ...
	'Value',2);
end
      
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'ListboxTop',0, ...
	'Position', [15 240 60 20], ...
	'String','44100', ...
	'Style','edit', ...
	'Tag','EditText1');
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'ListboxTop',0, ...
	'Position',[15 190 60 20], ...
	'String','255', ...
	'Style','edit', ...
	'Tag','EditText2', ...
	'UserData','[ ]');
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'ListboxTop',0, ...
	'Position',[15 140 60 20], ...
	'String','40',...
	'Style','edit', ...
	'Tag','EditText3');
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'ListboxTop',0, ...
	'Position',[15 90 60 20], ...
	'String','40',...
	'Style','edit', ...
	'Tag','EditText4');
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[1 1 1], ...
	'ListboxTop',0, ...
	'Position',[15 30 90 20], ...
	'String','MyOEM.mat',...
	'Style','edit', ...
	'Tag','EditText5');    
    
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.701960784313725 0.701960784313725 0.701960784313725], ...
	'Callback','OEMtool(1)', ...
	'ListboxTop',0, ...
	'Position',[15 60 80 20], ...
	'String','Update params', ...
	'Tag','Pushbutton1', ...
	'UserData','[ ]');
    
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
	'BackgroundColor',[0.701960784313725 0.701960784313725 0.701960784313725], ...
	'Callback','OEMtool(100)', ...
	'ListboxTop',0, ...
	'Position',[15 10 80 20], ...
	'String','Store', ...
	'Tag','Pushbutton2', ...
	'UserData','[ ]');
        
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
	'ListboxTop',0, ...
	'Position',[15 360 110 16], ...
	'String','Correction type',...
	'Style','text', ...
	'Tag','StaticText1');    
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
	'ListboxTop',0, ...
	'Position',[15 310 110 16], ...
	'String','Filter type',...
	'Style','text', ...
	'Tag','StaticText2');       
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
	'ListboxTop',0, ...
	'Position',[15 260 110 16], ...
	'String','Sampling rate',...
	'Style','text', ...
	'Tag','StaticText3');  
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
	'ListboxTop',0, ...
	'Position',[15 210 110 16], ...
	'String','FIR order',...
	'Style','text', ...
	'Tag','StaticText3');  
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
	'ListboxTop',0, ...
	'Position',[15 160 110 16], ...
	'String','IIR order (den)',...
	'Style','text', ...
	'Tag','StaticText4');  
h1 = uicontrol('Parent',h0, ...
	'Units','points', ...
	'ListboxTop',0, ...
	'Position',[15 110 110 16], ...
	'String','IIR order (num)',...
	'Style','text', ...
	'Tag','StaticText5');  
           
if nargout > 0, fig = h0; end

%%%%%%%%%%%%%%%%%% Active
else

h=findobj(gcf,'Tag','PopupMenu1');
crttypes=get(h,'String');crttype=crttypes(get(h,'Value'),:);
h=findobj(gcf,'Tag','PopupMenu2');
ftypes=get(h,'String');ftype=deblank(ftypes(get(h,'Value'),:));
h=findobj(gcf,'Tag','EditText1');
FS=str2num(get(h,'String'));
h=findobj(gcf,'Tag','EditText2');
ord0=str2num(get(h,'String'));
h=findobj(gcf,'Tag','EditText3');
iira=str2num(get(h,'String'));
h=findobj(gcf,'Tag','EditText4');
iirb=str2num(get(h,'String'));

impss=[1 zeros(1,1499)];
switch action, 
  case 1
[Cr,fr,Crdb]=OutMidCrct(crttype,ord0,FS);
[a,b]=Make_OEM(FS,ord0,crttype,ftype,iira,iirb);

if ftype(1)~='W',
  FF=freqz(a,b,ord0);FF=20*log10(abs(FF));
else
  irr=wfilter(a,b,impss,barkwarp(FS));
  FF=freqz(irr,1,ord0);FF=20*log10(abs(FF));
end
Crdb=-Crdb*2;Crdb=Crdb-max(Crdb);
FF=FF-max(FF);
semilogx(fr,Crdb,'-',fr,FF,'--');axis([100 FS/2 -100 0]);


ttext=[crttype ' '  ftype ' approximation'];
text(500,-60,['solid - ' crttype ' data']);
text(500,-70,['dashed - ' ttext]); 
xlabel('Frequency [Hz]');ylabel('Magnitude [dB]');
title('Outer and middle ear filter');
grid;
case 100
  h=findobj(gcf,'Tag','EditText5');
  fname=get(h,'String');

  [a,b]=Make_OEM(FS, ord0,crttype,ftype,iira,iirb);
  todisk=['a b'];
  if ftype(1)=='W', lam=barkwarp(FS);todisk=[todisk ' lam'];end
  eval(['save ' fname ' ' todisk]);
end
end
