function cs=Plack98_compress(cs,knee,nonlog)
%
% c=Plack98_compress(s,knee)
%
% Compression function from (Plack, 1998)
% knee is 35 dB by default
%
% This file is a part of HUTear- Matlab toolbox for auditory
% modeling. The toolbox is available at 
% http://www.acoustics.hut.fi/software/HUTear/

% Copyrights: Aki Hrm, Helsinki University of Technology, 
% Laboratory of Acoustics and Audio Signal Processing, 
% Espoo, Finland.
% Date: August 20 1999
% Email: Aki.Harma@hut.fi



if nargin==1, knee=35;end
if nargin<3, nonlog=0;end

if nonlog~=0, cs=20*log10(cs);end

belowknee=find(cs<=knee);
aboveknee=find(cs>knee);

cs(belowknee)=0.78*cs(belowknee);
cs(aboveknee)=0.16*cs(aboveknee)+21.7;

if nonlog~=0, cs=10.^(cs/20);end




