function ret=TempWin98(S,FS)
%
% ret=TempWin98(S)
%
% Efficient DSP implementation of the temporal window function 
% presented in (Plack&Oxenham, 1998)
%
% Note: Signals are rows
%
% This file is a part of HUTear- Matlab toolbox for auditory
% modeling. The toolbox is available at 
% http://www.acoustics.hut.fi/software/HUTear/

% Copyrights: Aki Hrm, Helsinki University of Technology, 
% Laboratory of Acoustics and Audio Signal Processing, 
% Espoo, Finland.
% Date: August 20 1999
% Email: Aki.Harma@hut.fi


dim=size(S);
FS=FS/1000;
A=0.975; B=0.025; 
b1=exp(-1/(4*FS));
b2=exp(-1/(29*FS));

rS=flipud([S(2:(length(S)),:); zeros(1,dim(2))]);

ret1=filter([A+B -(A*b2+B*b1)],[1 -b1-b2 b1*b2],S);
ret2=flipud(filter(1,[1 -exp(-1/(3.5*FS))],rS));

ret=ret1+ret2;
