function ret=noise(len,level);
%	ret=noise(LEN,LEVEL);
% This function generates a zero-mean noise sequence of length LEN.
% The maximum value of the sequence is LEVEL
%	If LEVEL is of type [a b], the produced signal is a a-b-band noise
%	with max level=1.
%
% This file is a part of HUTear- Matlab toolbox for auditory
% modeling. The toolbox is available at 
% http://www.acoustics.hut.fi/software/HUTear/

% Copyrights: Aki Hrm, Helsinki University of Technology, 
% Laboratory of Acoustics and Audio Signal Processing, 
% Espoo, Finland.
% Date: August 20 1999
% Email: Aki.Harma@hut.fi

if nargin<2, level=1; end;
if length(level)==2,
   n=(rand(1,len)-0.5)*2;
   if level(1)==0, c=fir1(300,level(2));
	elseif level(2)==1, c=fir1(200,level(1),'high'); 
	else c=fir1(500,[level(1) level(2)]);
	end
   ret=filter(c,1,n);
else   
ret=level*(rand(1,len)-0.5)*2;
end
