% Profile_test
%
% This profile was designed just to test the package with
% HUTear_intro script.
% 
% This file is a part of HUTear- Matlab toolbox for auditory
% modeling. The toolbox is available at 
% http://www.acoustics.hut.fi/software/HUTear/

% Copyrights: Aki Hrm, Helsinki University of Technology, 
% Laboratory of Acoustics and Audio Signal Processing, 
% Espoo, Finland.
% Date: August 20 1999
% Email: Aki.Harma@hut.fi
clear model;

% General parameters
model.id = 'An arbitrary test model';
model.fs = 44100; % Sampling frequency
model.ds = 1;     % Outputs downsampled to rate fs/ds

% Outer and middle ear filtering
model.outmid.id='Fixed filter'; 
model.outmid.file='MAF255';

% Model for inner ear 
model.cochlea.id='Custom gammatone filterbank';
model.cochlea.fb.file='mybank';
model.cochlea.asymmcomp=1;

% Mechanical to neural - haircell
model.haircell.id = 'Half-wave rectification, compression, and _filtering';
% Rectification
model.haircell.rcf.r='half';
% Compression
model.haircell.rcf.c=0.7;
% Smoothing
model.haircell.rcf.f='no';
% Thresholding
model.haircell.rcf.thrhld=0.1;

% Neural adaptation
model.neural.id ='Sliding temporal window function';
model.neural.function ='Plack98';

% Post-processing
model.pp.id = 'Decibel scale';
model.pp.mapping='decibel';






